// an example using weka 3.7.1
import java.io.File;

import weka.classifiers.trees.J48;
import weka.core.Instance;
import weka.core.Instances;
import weka.core.converters.ArffLoader;

public class Sample {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// 学習データの読み込み
		File arff = new File("learn.arff");
		Instances instances = null;
		try {
			ArffLoader loader = new ArffLoader();
			loader.setFile(arff);
			instances = loader.getDataSet();
			instances.setClassIndex(instances.numAttributes() - 1);
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}
		// System.err.println(instances);

		// J48というアルゴリズムで機械学習器を sample.arff から読んたデータをもとに生成
		J48 classifier = new J48();
		try {
			classifier.buildClassifier(instances);
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}

		// テストデータの読み込み
		File arfft = new File("test.arff");
		Instances instancest = null;
		try {
			ArffLoader loader = new ArffLoader();
			loader.setFile(arfft);
			instancest = loader.getDataSet();
			instancest.setClassIndex(instances.numAttributes() - 1);
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}
		
		
		// 学習結果に基づき予想
		try {
			for (Instance inst : instancest) {
				double d = classifier.classifyInstance(inst);
				System.out.println(inst+" => "+d+" (0=windows 1=mac 2=linux)");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

}
